pgsql: postgres user UID is now the one from inside the vserver if necessary
[matthijs/upstream/backupninja.git] / handlers / pgsql
1 # -*- mode: sh; sh-basic-offset: 3; indent-tabs-mode: nil; -*-
2 #
3 # PostgreSQL handler script for backupninja
4 #
5
6 getconf backupdir /var/backups/postgres
7 getconf databases all
8 getconf compress yes
9 getconf vsname
10
11 localhost=`hostname`
12
13 # Decide if the handler should operate on a vserver or on the host.
14 # In the former case, check that $vsname exists and is running.
15 local usevserver=no
16 local vroot
17 if [ $vservers_are_available = yes ]; then
18    if [ -n "$vsname" ]; then
19       # does it exist ?
20       if ! vservers_exist "$vsname" ; then
21          fatal "The vserver given in vsname ($vsname) does not exist."
22       fi
23       # is it running ?
24       $VSERVERINFO -q $vsname RUNNING
25       if [ $? -ne 0 ]; then
26          fatal "The vserver $vsname is not running."
27       fi
28       # everything ok
29       info "Using vserver '$vsname'."
30       usevserver=yes
31       vroot="$VROOTDIR/$vsname"
32    else
33       info "No vserver name specified, actions will be performed on the host."
34    fi
35 fi
36
37 # Make sure that the system to backup has the needed executables
38 if [ $usevserver = yes ]; then
39    debug "Examining vserver '$vsname'."
40    if [ "$databases" == "all" ]; then
41       [ -x "$vroot`$VSERVER $vsname exec which $PGSQLDUMPALL`" ] || \
42          fatal "Can't find $PGSQLDUMPALL in vserver $vsname."
43    else
44       [ -x "$vroot`$VSERVER $vsname exec which $PGSQLDUMP`" ] || \
45          fatal "Can't find $PGSQLDUMP in vserver $vsname."
46    fi
47 else
48    if [ "$databases" == "all" ]; then
49       [ -x "`which $PGSQLDUMPALL`" ] || \
50          fatal "Can't find $PGSQLDUMPALL."
51    else
52       [ -x "`which $PGSQLDUMP`" ] || \
53          fatal "Can't find $PGSQLDUMP."
54    fi
55 fi
56
57 # create backup dir, the vroot variable will be empty if no vsname was specified
58 # and will proceed to operate on the host
59 [ -d $vroot$backupdir ] || (debug "mkdir -p $vroot$backupdir"; mkdir -p $vroot$backupdir)
60 [ -d $vroot$backupdir ] || fatal "Backup directory '$vroot$backupdir'"
61
62 # give backup dir the good uid and permissions
63 # (in respect to the vserver, if $usevserver = yes)
64 if [ $usevserver = yes ]; then
65    pguid=`$VSERVER $vsname exec getent passwd postgres | awk -F: '{print $3}'`
66 else
67    pguid=`getent passwd postgres | awk -F: '{print $3}'`
68 fi
69 [ -n "$pguid" ] || \
70     fatal "No user called postgres`[ $usevserver = no ] || echo \" on vserver $vsname\"`."
71 debug "chown $pguid $vroot$backupdir"
72 chown $pguid $vroot$backupdir
73 debug "chmod 700 $vroot$backupdir"
74 chmod 700 $vroot$backupdir
75
76 # if $databases = all, use pg_dumpall
77 if [ "$databases" == "all" ]; then
78     if [ $usevserver = yes ]; then
79         execstr="$VSERVER $vsname exec su - postgres -c \"$PGSQLDUMPALL > $backupdir/${vsname}.sql\""
80     else
81         execstr="su - postgres -c \"$PGSQLDUMPALL > $backupdir/${localhost}-all.sql\""
82     fi
83     debug "$execstr"
84     if [ ! $test ]; then
85        output=`eval $execstr 2>&1`
86        code=$?
87         if [ "$code" == "0" ]; then
88             debug $output
89             info "Successfully finished dump of pgsql cluster"
90         else
91             warning $output
92             warning "Failed to dump pgsql cluster"
93         fi
94     fi
95     
96 # else use pg_dump on each specified database
97 else
98     for db in $databases; do
99         if [ $usevserver = yes ]
100             then
101             execstr="$VSERVER $vsname exec su - postgres -c \"$PGSQLDUMP $db > $backupdir/${db}.sql\""
102         else
103             execstr="su - postgres -c \"$PGSQLDUMP $db > $backupdir/${db}.sql\""
104         fi
105         debug "$execstr"
106         if [ ! $test ]; then
107             output=`eval $execstr 2>&1`
108             code=$?
109             if [ "$code" == "0" ]; then
110                 debug $output
111                 info "Successfully finished dump of pgsql database ${db}"
112             else
113                 warning $output
114                 warning "Failed to dump pgsql database ${db}"
115             fi
116         fi
117     done
118 fi
119
120 if [ "$compress" == "yes" ]; then
121     output=`$GZIP -f $vroot$backupdir/*.sql 2>&1`
122     debug $output
123 fi
124
125 return 0
126